//+-----------------------------------------------------------------------------+
//|                                                  Pips_to_ribbons_via_gvs.mq4|
//|                                                       Copyright  2014 Radar|
//|                                          http://www.hopwood3.freeserve.co.uk|
//+-----------------------------------------------------------------------------+
#property copyright "Copyright  2014 Radar"
#property link      "http://www.hopwood3.freeserve.co.uk"
#property strict
#property indicator_chart_window


extern string  myFont   = "Times" ;// "Eras Bold ITC"
extern int     myFontSize  = 12 ;
extern int     Offset_x = 120;
extern int     Offset_y = 30;

//Tick Ribbon 

////////////////////////////////////////////////////////////////////////////////////////
string MA_Name1, MA_Name2;
int CTF;
////////////////////////////////////////////////////////////////////////////////////////
// The code that adapts the bot to x digit criminals is in void PFactor() and sets the global variable 'factor'.
// Usage is, for example, double stop = OrderOpenPrice() - (StopLoss / factor).

//double PFactor(string pair)

//Calculating the factor needed to turn pip values into their correct points value to accommodate different Digit size.
//Thanks to Lifesys for providing this code. Coders, you need to briefly turn of Wrap and turn on a mono-spaced font to view this properly and see how easy it is to make changes.
string          pipFactor[]  = {"JPY","XAG","SILVER","BRENT","WTI","XAU","GOLD","SP500","S&P","UK100","WS30","DAX30","DJ30","NAS100","CAC400"};
double          pipFactors[] = { 100,  100,  100,     100,    100,  10,   10,    10,     10,   1,      1,     1,      1,     1,       1};
double          factor;//For pips/points stuff. Set up in int init()
////////////////////////////////////////////////////////////////////////////////////////



int init()
{  //HideTestIndicators(true);
   factor = PFactor(Symbol());
return(0);
}

int deinit()
{  
   string Name;
   for(int index = ObjectsTotal() -1 ;index >= 0; index--)
   {
      Name = ObjectName(index);
      if (StringSubstr(Name, 0, 6) == "Ribbon")
      {
         ObjectDelete(Name);
      }
   }
return(0);
}

int start()
{
   int Gapx = Offset_x;
   int TFGap = Offset_y;
   
   //double cl=Bid; //(0,0,i);
   for (int i = -1; i <=5; i++)
   {
      SetTF(i);
      double MAFast = (GlobalVariableGet(StringConcatenate("Rib", Symbol(), Period(), "_", MA_Name1)) - Bid) * factor;
      double MASlow = (GlobalVariableGet(StringConcatenate("Rib", Symbol(), Period(), "_", MA_Name2)) - Bid) * factor;
      if (i == -1)
      {
         TFGap = TFGap;
         ObjectDelete("Ribbon" + MA_Name1);   
         ObjectCreate("Ribbon" + MA_Name1, OBJ_LABEL, 0, 0, 0);
         ObjectSetText("Ribbon" + MA_Name1, "Pips To "+ MA_Name1 +" : " + DoubleToStr(MAFast, 1),  myFontSize , myFont, LimeGreen );
         ObjectSet("Ribbon" + MA_Name1, OBJPROP_XDISTANCE,  myFontSize*Gapx); 
         ObjectSet("Ribbon" + MA_Name1, OBJPROP_YDISTANCE,  myFontSize*TFGap);

         TFGap = TFGap + 2;
         ObjectDelete("Ribbon" + MA_Name2);   
         ObjectCreate("Ribbon" + MA_Name2, OBJ_LABEL, 0, 0, 0);
         ObjectSetText("Ribbon" + MA_Name2, "Pips To " + MA_Name2 + " : " + DoubleToStr(MASlow, 1),  myFontSize , myFont, LimeGreen );
         ObjectSet("Ribbon" + MA_Name2, OBJPROP_XDISTANCE,  myFontSize*Gapx); 
         ObjectSet("Ribbon" + MA_Name2, OBJPROP_YDISTANCE,  myFontSize*TFGap);
      }
      else
      {
         TFGap = TFGap + 2;
         ObjectDelete("Ribbon" + MA_Name1);   
         ObjectCreate("Ribbon" + MA_Name1, OBJ_LABEL, 0, 0, 0);
         ObjectSetText("Ribbon" + MA_Name1, "Pips To "+ MA_Name1 +" : " + DoubleToStr(MAFast, 1),  myFontSize , myFont, LimeGreen );
         ObjectSet("Ribbon" + MA_Name1, OBJPROP_XDISTANCE,  myFontSize*Gapx); 
         ObjectSet("Ribbon" + MA_Name1, OBJPROP_YDISTANCE,  myFontSize*TFGap);

         TFGap = TFGap + 2;
         ObjectDelete("Ribbon" + MA_Name2);   
         ObjectCreate("Ribbon" + MA_Name2, OBJ_LABEL, 0, 0, 0);
         ObjectSetText("Ribbon" + MA_Name2, "Pips To " + MA_Name2 + " : " + DoubleToStr(MASlow, 1),  myFontSize , myFont, LimeGreen );
         ObjectSet("Ribbon" + MA_Name2, OBJPROP_XDISTANCE,  myFontSize*Gapx); 
         ObjectSet("Ribbon" + MA_Name2, OBJPROP_YDISTANCE,  myFontSize*TFGap);
      }
   }
  
return(0);
}

double PFactor(string symbol)
{
   // This code supplied by Lifesys. Many thanks Paul - we all owe you.
   // Gary was trying to make me see this, but I could not understand his explanation. Paul used Janet and John words
   
   for ( int i = ArraySize(pipFactor)-1; i >=0; i-- ) 
      if (StringFind(symbol,pipFactor[i],0) != -1) 
         return (pipFactors[i]);
   return(10000);

}//End double PFactor(string pair)

int SetTF(int levelsUP)
{

   int timeframe=Period(); // minutes
   int nextTF=timeframe;
   MA_Name1 = StringConcatenate("M", string(Period()), "_Fast");
   MA_Name2 = StringConcatenate("M", string(Period()), "_Slow");
   if (levelsUP>=1)
   {
      nextTF=getNextTF(timeframe);
   }
   if (levelsUP>=2)
   {
      nextTF=getNextTF(nextTF);
   }
   if (levelsUP>=3)
   {
      nextTF=getNextTF(nextTF);
   }
   if (levelsUP>=4)
   {
      nextTF=getNextTF(nextTF);
   }
   if ((levelsUP>=5) && (Period() <= 15))
   {
      nextTF=getNextTF(nextTF);
   }
   
   if (levelsUP==-1) //shadow
   {
      nextTF=getPrevTF(timeframe);
   }
   return(nextTF);
}

int getNextTF(int tf)
{
   int nextTF=5;
   MA_Name1 = "M5_Fast";
   MA_Name2 = "M5_Slow";
   CTF = 5;
   if (tf==5)
   {
      nextTF=15;
      MA_Name1 = "M15_Fast";
      MA_Name2 = "M15_Slow";
      CTF = 15;
   }
   else if (tf==15)
   {
      nextTF=30;
      MA_Name1 = "M30_Fast";
      MA_Name2 = "M30_Slow";
   }
   else if (tf==30)
   {
      nextTF=60;
      MA_Name1 = "H1_Fast";
      MA_Name2 = "H1_Slow";
   }
   else if (tf==60)
   {
      nextTF=240;
      MA_Name1 = "H4_Fast";
      MA_Name2 = "H4_Slow";
   }
   else if (tf==240)
   {
      nextTF=1440;   // D1
      MA_Name1 = "D1_Fast";
      MA_Name2 = "D1_Slow";
   }
   else if (tf==1440)
   {
      nextTF=10080;  // W1
      MA_Name1 = "W1_Fast";
      MA_Name2 = "W1_Slow";
   }
   else
      nextTF=0;
   return nextTF;
}

int getPrevTF(int tf)
{
   int prevTF=5;
      MA_Name1 = "M5_Fast";
      MA_Name2 = "M5_Slow";
   if (tf==5)
   {
      prevTF=1;
      MA_Name1 = "M1_Fast";
      MA_Name2 = "M1_Slow";
   }
   else if (tf==15)
   {
      prevTF=5;
      MA_Name1 = "M5_Fast";
      MA_Name2 = "M5_Slow";
   }
   else if (tf==30)
   {
      prevTF=15;
      MA_Name1 = "M15_Fast";
      MA_Name2 = "M15_Slow";
   }
   else if (tf==60)
   {
      prevTF=30;
      MA_Name1 = "M30_Fast";
      MA_Name2 = "M30_Slow";
   }
   else if (tf==240)
   {
      prevTF=60;
      MA_Name1 = "H1_Fast";
      MA_Name2 = "H1_Slow";
   }
   else if (tf==1440)
   {
      prevTF=240;
      MA_Name1 = "H4_Fast";
      MA_Name2 = "H4_Slow";
   }
   return prevTF;
}