//+------------------------------------------------------------------+
//|                                                    MA ribbon.mq4 |
//|                                               mladenfx@gmail.com |
//|                                                                  |
//| original idea by Jose Silva                                      |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
// modification kinonen Fev 2009 & 2010
//
// T3MA_ribbon_multi.mq4 (padnoter)
// modified padnoter May 2014. Allows ribbons in levels as per "slowkey"
//    level0 is always current tf. level1 is the next MT4 tf up etc.
//    means 7 indis will do current tf plus 5 levels up plus a shadow down... 
//    which will also work as you change TF (no need for more indi & visualisation off)

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DarkSlateGray
#property indicator_color2 DarkSlateGray
#property indicator_color3 White
#property indicator_color4 Crimson
#property indicator_width1 5
#property indicator_width2 5
#property indicator_width3 3
#property indicator_width4 3
#property strict
//
//
extern int       MA1Period=36;
extern double    factor1=0.54;
extern int       MA2Period =54;
extern double    factor2=0.63;
extern int       levelsUP=0;
extern color     level0color=DarkSlateGray;
extern color     level1color=Navy;
extern color     level2color=DarkGreen;
extern color     level3color=Brown;
extern color     level4color=C'77,55,4'; //=DarkDarkGoldenrod
extern color     level5color=C'27,44,44'; //=screen door

extern int       TimeFrame =0;
extern int       NbOfCandles=500;
//
extern string    p2r = "-=-=Pips to Ribbons=-=-";
extern string    myFont   = "Times" ;// "Eras Bold ITC"
extern int       myFontSize  = 14 ;
extern bool      ShowPips2Ribbons = false;
extern int       Offset_x = 100;
extern int       Offset_y = 50;
extern bool      CreateGV = true;


color  ribbonColor=level0color;
color  fastColor=White;
bool   screenDoor=False;
double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];

string MA_Name1, MA_Name2;
int    TFGap, ObjCount;

////////////////////////////////////////////////////////////////////////////////////////
// The code that adapts the bot to x digit criminals is in void PFactor() and sets the global variable 'factor'. Usage is, for example, double stop = OrderOpenPrice() - (StopLoss / factor).

//double PFactor(string pair)

//Calculating the factor needed to turn pip values into their correct points value to accommodate different Digit size.
//Thanks to Lifesys for providing this code. Coders, you need to briefly turn of Wrap and turn on a mono-spaced font to view this properly and see how easy it is to make changes.
string          pipFactor[]  = {"JPY","XAG","SILVER","BRENT","WTI","XAU","GOLD","SP500","S&P","UK100","WS30","DAX30","DJ30","NAS100","CAC400"};
double          pipFactors[] = { 100,  100,  100,     100,    100,  10,   10,    10,     10,   1,      1,     1,      1,     1,       1};
double          pipfinder;//For pips/points stuff. Set up in int init()
////////////////////////////////////////////////////////////////////////////////////////

double PFactor(string symbol)
{
   //This code supplied by Lifesys. Many thanks Paul - we all owe you. Gary was trying to make me see this, but I could not understand his explanation. Paul used Janet and John words
   
   for ( int i = ArraySize(pipFactor)-1; i >=0; i-- ) 
      if (StringFind(symbol,pipFactor[i],0) != -1) 
         return (pipFactors[i]);
   return(10000);

}//End double PFactor(string pair)



int init()
{  //HideTestIndicators(true);
   pipfinder = PFactor(Symbol());

   int timeframe=Period(); // minutes
   int nextTF=timeframe;
   MA_Name1 = StringConcatenate("M", string(Period()), "_Fast");
   MA_Name2 = StringConcatenate("M", string(Period()), "_Slow");
   SetIndexLabel(2, MA_Name1);
   SetIndexLabel(3, MA_Name2);
   if (levelsUP>=1)
   {
      nextTF=getNextTF(timeframe);
      ribbonColor=level1color;
   }
   if (levelsUP>=2)
   {
      nextTF=getNextTF(nextTF);
      ribbonColor=level2color;
   }
   if (levelsUP>=3)
   {
      nextTF=getNextTF(nextTF);
      ribbonColor=level3color;
   }
   if (levelsUP>=4)
   {
      nextTF=getNextTF(nextTF);
      ribbonColor=level4color;
   }
   if (levelsUP>=5)
   {
      nextTF=getNextTF(nextTF);
      ribbonColor=level5color;
   }
   
   if (levelsUP==-1) //shadow
   {
      nextTF=getPrevTF(timeframe);
   }
   MA1Period=MA1Period*nextTF/timeframe;
   MA2Period=MA2Period*nextTF/timeframe;

   if (levelsUP>=0)
   {
      SetIndexBuffer(0,buffer3); SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID, 5, ribbonColor);
      SetIndexBuffer(1,buffer4); SetIndexStyle(1,DRAW_HISTOGRAM, STYLE_SOLID, 5, ribbonColor);
      SetIndexStyle(2,DRAW_LINE, STYLE_SOLID, 3, fastColor);
      if (screenDoor) // W1
      {
         ribbonColor=level5color;
         SetIndexBuffer(0,buffer3); SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_DOT, 1, ribbonColor);
         SetIndexBuffer(1,buffer4); SetIndexStyle(1,DRAW_HISTOGRAM, STYLE_DOT, 1, ribbonColor);
      }
   }
   else // shadow
   {
      SetIndexBuffer(0,buffer3); SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID, 1, CLR_NONE);
      SetIndexBuffer(1,buffer4); SetIndexStyle(1,DRAW_HISTOGRAM, STYLE_SOLID, 1, CLR_NONE);
      SetIndexStyle(2,DRAW_LINE, STYLE_SOLID, 3, PaleGoldenrod);
   }
   SetIndexBuffer(2,buffer1);
   SetIndexBuffer(3,buffer2);

   return(0);
}

int getNextTF(int tf)
{
   int nextTF=5;
   MA_Name1 = "M5_Fast";
   MA_Name2 = "M5_Slow";
   SetIndexLabel(2, MA_Name1);
   SetIndexLabel(3, MA_Name2);
   if (tf==5)
   {
      nextTF=15;
      MA_Name1 = "M15_Fast";
      MA_Name2 = "M15_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
   }
   else if (tf==15)
   {
      nextTF=30;
      MA_Name1 = "M30_Fast";
      MA_Name2 = "M30_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
   }
   else if (tf==30)
   {
      nextTF=60;
      MA_Name1 = "H1_Fast";
      MA_Name2 = "H1_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
   }
   else if (tf==60)
   {
      nextTF=240;
      MA_Name1 = "H4_Fast";
      MA_Name2 = "H4_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
   }
   else if (tf==240)
   {
      nextTF=1440;   // D1
      MA_Name1 = "D1_Fast";
      MA_Name2 = "D1_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
      fastColor=Yellow;
   }
   else if (tf==1440)
   {
      nextTF=10080;  // W1
      MA_Name1 = "W1_Fast";
      MA_Name2 = "W1_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
      fastColor=Yellow;
      screenDoor=True;
   }
   else
      nextTF=0;
   return nextTF;
}

int getPrevTF(int tf)
{
   int prevTF=5;
      MA_Name1 = "M5_Fast";
      MA_Name2 = "M5_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
   if (tf==5)
   {
      prevTF=1;
      MA_Name1 = "M1_Fast";
      MA_Name2 = "M1_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
   }
   else if (tf==15)
   {
      prevTF=5;
      MA_Name1 = "M5_Fast";
      MA_Name2 = "M5_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
   }
   else if (tf==30)
   {
      prevTF=15;
      MA_Name1 = "M15_Fast";
      MA_Name2 = "M15_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
   }
   else if (tf==60)
   {
      prevTF=30;
      MA_Name1 = "M30_Fast";
      MA_Name2 = "M30_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
   }
   else if (tf==240)
   {
      prevTF=60;
      MA_Name1 = "H1_Fast";
      MA_Name2 = "H1_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
   }
   else if (tf==1440)
   {
      prevTF=240;
      MA_Name1 = "H4_Fast";
      MA_Name2 = "H4_Slow";
      SetIndexLabel(2, MA_Name1);
      SetIndexLabel(3, MA_Name2);
   }
   return prevTF;
}
int deinit()
{
   if (ShowPips2Ribbons)
   {
      string Name;
      for(int index = ObjectsTotal() -1 ;index >= 0; index--)
      {
         Name = ObjectName(index);
         if (StringSubstr(Name, 0, 6) == "Ribbon")
         {
            ObjectDelete(Name);
         }
      }
   }
   
   if (CreateGV)
   {
      for (int index = GlobalVariablesTotal() - 1; index >= 0; index--)
      {
         string Name = GlobalVariableName(index);
         if (StringSubstr(Name, 0, 9) == StringConcatenate("Rib" + Symbol()))
         {
            GlobalVariableDel(Name);
         }
      }
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//

int start()
{
   int TFGap2;
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   if (MA1Period==0) return(0); //out of range

//   Alert("cb="+counted_bars+" limit="+limit+" max="+NbOfCandles);
   limit = MathMin(limit, NbOfCandles);
   for(i=0; i<limit; i++)  
   {
      buffer1[i] = iCustom(NULL,TimeFrame,"T3MA",MA1Period,factor1,0,i);
      buffer2[i] = iCustom(NULL,TimeFrame,"T3MA",MA2Period,factor2,0,i);
      buffer3[i] = buffer1[i];
      buffer4[i] = buffer2[i];
   }

// First attempt to make info available to other indies, & future EA's...
//
   if (CreateGV)
   {
      GlobalVariableSet(StringConcatenate("Rib" + Symbol() + string(Period()) + "_" + MA_Name1), buffer3[0]);
      GlobalVariableSet(StringConcatenate("Rib" + Symbol() + string(Period()) + "_" + MA_Name2), buffer4[0]);
   }
// Finally got it working after a few more hours.

// I got frustrated with trying to pull the info into a separate indi, so
// I threw this bit together...

   if (ShowPips2Ribbons)
   {
      ObjectDelete("Ribbon" + MA_Name2);   
      ObjectCreate("Ribbon" + MA_Name2, OBJ_LABEL, 0, 0, 0);
      ObjectSetText("Ribbon" + MA_Name2, "Pips To " + MA_Name2 + " : " + DoubleToStr(((buffer4[0] - Bid) * pipfinder), 1), myFontSize , myFont, LimeGreen );
      ObjectSet("Ribbon" + MA_Name2, OBJPROP_XDISTANCE,  myFontSize*Offset_x); 
      ObjectSet("Ribbon" + MA_Name2, OBJPROP_YDISTANCE,  myFontSize*Offset_y);

      TFGap2 = Offset_y - 2;
      ObjectDelete("Ribbon" + MA_Name1);   
      ObjectCreate("Ribbon" + MA_Name1, OBJ_LABEL, 0, 0, 0);
      ObjectSetText("Ribbon" + MA_Name1, "Pips To "+ MA_Name1 +" : " + DoubleToStr(((buffer3[0] - Bid) * pipfinder), 1), myFontSize , myFont, LimeGreen );
      ObjectSet("Ribbon" + MA_Name1, OBJPROP_XDISTANCE,  myFontSize*Offset_x); 
      ObjectSet("Ribbon" + MA_Name1, OBJPROP_YDISTANCE,  myFontSize*TFGap2);
    }
    return(0);
}

